<template>
  <div class="lista-pedidos">
    <v-btn big color="success" class="btn-baixar-lista-pedidos" @click="btnBaixarPedidoManual()">
      <v-icon>mdi-thumb-up</v-icon> Baixar
    </v-btn>

    <div class="lista-pedidos-pententes-concluidos lista-sem-formatacao">
      <ul>
        <li v-for="pedido in pedidos.dados.filter(p => {return (p.status_id == 2 || p.status_id == 3)})" :key="pedido.id">
          <v-btn color="info" width="100%" @click="selecionaPedidoPendente(pedido)" v-show="pedido.status_id == 2">
            {{zerosEsquerda(pedido.id)}}
          </v-btn>
          <v-btn color="success" width="100%" @click="selecionaPedidoConcluido(pedido)" v-show="pedido.status_id == 3">
            {{zerosEsquerda(pedido.id)}}
          </v-btn>
        </li>
      </ul>
    </div>

    <v-snackbar v-model="snackbarBaixar" :timeout="timeout">
      {{ text }}
      <v-btn color="white" text @click="snackbarBaixar = false">
        Close
      </v-btn>
    </v-snackbar>

    <!-- BAIXA AUTOMATICA -->
    <v-dialog v-model="confirmarPedidoDialog" max-width="390">
      <v-card>
        <v-card-title class="headline">Deseja baixar o pedido {{pedidoSelecionado.id}}?</v-card-title>

        <!-- <v-card-text>
          Detalhes do Pedido:<br><br>
          1 Hambúrguer<br>
          1 Refri Fanta
        </v-card-text> -->

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn color="red darken-1" text @click="confirmarPedidoDialog = false">
            Desistir
          </v-btn>

          <v-btn color="green darken-1" text @click="confirmaBaixarPedido()">
            Confirmar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- BAIXA MANUAL -->
    <v-dialog v-model="confirmarPedidoDialogManual" max-width="390">
      <v-card>
        <v-card-title class="headline">Informe o número do pedido:</v-card-title>

        <v-card-text>
          <v-text-field v-model="numeroPedido" label="Nº Pedido" outlined required></v-text-field>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn color="red darken-1" text @click="confirmarPedidoDialogManual = false">
            Desistir
          </v-btn>

          <v-btn color="green darken-1" text @click="confirmaBaixarPedido(numeroPedido)">
            Confirmar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- DESBAIXAR PEDIDO -->
    <v-dialog v-model="confirmarDesbaixarPedidoDialog" max-width="390">
      <v-card>
        <v-card-title class="headline">Deseja DESBAIXAR o pedido {{pedidoSelecionado.id}}?</v-card-title>

        <!-- <v-card-text>
          Detalhes do Pedido:<br><br>
          1 Hambúrguer<br>
          1 Refri Fanta
        </v-card-text> -->

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn color="red darken-1" text @click="confirmarDesbaixarPedidoDialog = false">
            Desistir
          </v-btn>

          <v-btn color="green darken-1" text @click="confirmaDesbaixarPedido()">
            Confirmar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </div>
</template>

<script>
  export default {
    name: 'ListaPedidosBaixar',
    inject: ['zerosEsquerda'],
    props: [
      'pedidos'
    ],
    data() {
      return {
        teste: null,
        snackbarBaixar: false,
        text: 'Baixado!!!',
        timeout: 2000,
        confirmarPedidoDialog: false,
        confirmarPedidoDialogManual: false,
        confirmarDesbaixarPedidoDialog: false,
        pedidoSelecionado: {id:0},
        numeroPedido: '',
      }
    },
    methods: {
      btnBaixarPedidos: function () {
        console.log("ListaPedidosBaixar btnBaixarPedidos");

        this.confirmarPedidoDialog = true;
      },
      btnBaixarPedidoManual: function () {
        console.log("ListaPedidosBaixar btnBaixarPedidos");

        this.confirmarPedidoDialogManual = true;
      },
      confirmaBaixarPedido: function (id = null) {
        console.log("ListaPedidosBaixar confirmaBaixarPedido", id);

        
        if (id == null){
          this.$parent.$parent.baixarPedido(this.pedidoSelecionado.id);
          this.confirmarPedidoDialog = false;
        } else {
          this.$parent.$parent.baixarPedido(id);
          this.confirmarPedidoDialogManual = false;
        }

        this.numeroPedido = "";
        this.snackbarBaixar = true;
      },
      confirmaDesbaixarPedido: function () {
        console.log("ListaPedidosBaixar confirmaDesbaixarPedido", this.pedidoSelecionado.id);

        this.$parent.$parent.desbaixarPedido(this.pedidoSelecionado.id);

        this.confirmarDesbaixarPedidoDialog = false;
      },
      selecionaPedidoPendente: function (pedido) {
        console.log("ListaPedidosBaixar selecionaPedidoPendente", pedido);

        this.pedidoSelecionado = pedido;
        this.confirmarPedidoDialog = true;
      },
      selecionaPedidoConcluido: function (pedido) {
        console.log("ListaPedidosBaixar selecionaPedidoConcluido", pedido);

        this.pedidoSelecionado = pedido;
        this.confirmarDesbaixarPedidoDialog = true;
      }
    }
  }
</script>

<style lang="scss">
  .lista-pedidos {
    text-align: center;
  }

  .btn-baixar-lista-pedidos {
    margin-bottom: 20px;
  }

  .lista-sem-formatacao ul {
    list-style-type: none;
    margin-left: 0 !important;
    padding: 0;
  }

  .lista-sem-formatacao li {
    margin: 0;
    padding: 0 0 10px;
  }

  .v-application ul {
    padding-left: 3px !important;
  }
</style>